#include <stdio.h>
#include <math.h>

#define FS		33133.0
#define FSTD_N	16384

double fstd[FSTD_N];
int t[128];

main() {
	int i, d;
	for (i = 0; i < FSTD_N; i++) 
		fstd[i] = 440.0 * pow(2.0, (i - 6900) / 1200.0);
	int max = 0;
	for (i = 0; i < 128; i++) {
		int b, dif;
		d = 0x20000 * fstd[100 * i] / FS + 0.5;
		t[i] = d;
		double f = FS * d / 0x20000;
		for (b = FSTD_N / 2, dif = FSTD_N / 4; dif; dif >>= 1) 
			if (fstd[b] < f) b += dif;
			else if (fstd[b] > f) b -= dif;
		printf(";%d %d %lf %d cents\r\n", i, d, f, b - 100 * i);
	}
	for (i = 0; i < 128; i++) 
		printf("\tde\t0x%02x,0x%02x\r\n", t[i] & 0xff, t[i] >> 8 & 0xff);
	return 0;
}
